////////////////////////////////////////////////////////////////////////////////
// CONFIDENTIAL and PROPRIETARY software of Magewell Electronics Co., Ltd.
// Copyright (c) 2011-2014 Magewell Electronics Co., Ltd. (Nanjing) 
// All rights reserved.
// This copyright notice MUST be reproduced on all authorized copies.
////////////////////////////////////////////////////////////////////////////////

#include "linux-file.h"

#include <asm/uaccess.h>
#include <linux/sched.h>

struct file *linux_file_open(const char *path, int flags, int mode)
{
    struct file *filp = NULL;
    mm_segment_t oldfs;

    oldfs = get_fs();
    set_fs(get_ds());
    filp = filp_open(path, flags, mode);
    set_fs(oldfs);

    return filp;
}

void linux_file_close(struct file *file)
{
    filp_close(file, NULL);
}

ssize_t linux_file_read(struct file *file, loff_t offset, unsigned char *data, size_t size)
{
    mm_segment_t oldfs;
    ssize_t ret;

    oldfs = get_fs();
    set_fs(get_ds());
    ret = vfs_read(file, data, size, &offset);
    set_fs(oldfs);

    return ret;
}

ssize_t linux_file_write(struct file *file, loff_t offset, unsigned char *data, size_t size)
{
    mm_segment_t oldfs;
    ssize_t ret;

    oldfs = get_fs();
    set_fs(get_ds());
    ret = vfs_write(file, data, size, &offset);
    set_fs(oldfs);

    return ret;
}

